package org.xbib.interlibrary.db.medea.postgresql;

import java.io.IOException;
import java.util.List;
import org.xbib.interlibrary.api.ApplicationModule;
import org.xbib.interlibrary.api.config.ConfigManager;
import org.xbib.interlibrary.api.event.OrderEventManager;
import org.xbib.interlibrary.api.order.OrderManager;
import org.xbib.interlibrary.api.order.statistics.StatisticsManager;
import org.xbib.interlibrary.api.route.RouteManager;
import org.xbib.interlibrary.api.template.TemplateManager;
import org.xbib.interlibrary.http.HttpHelper;
import org.xbib.interlibrary.db.AbstractDatabaseModule;

public class MedeaDatabaseModule extends AbstractDatabaseModule {

    private HttpHelper httpHelper;

    public MedeaDatabaseModule() {
        super();
    }

    @Override
    public List<Class<? extends ApplicationModule>> dependsOn() {
        return null;
    }

    @Override
    protected void beforeOpen() throws IOException {
        this.httpHelper = new HttpHelper();
        httpHelper.open(getInterlibrary().getSettings().getAsSettings("http"));
    }

    @Override
    protected void afterOpen() throws IOException {
    }

    @Override
    protected ConfigManager createConfigManager() throws IOException {
        return new MedeaConfigManager(this);
    }

    @Override
    protected OrderEventManager createEventManager() throws IOException {
        return new MedeaOrderEventManager(this);
    }

    @Override
    protected OrderManager createOrderManager() throws IOException {
        return new MedeaOrderManager(this);
    }

    @Override
    protected RouteManager createRouteManager() throws IOException {
        return new MedeaRouteManager(this, httpHelper);
    }

    @Override
    protected StatisticsManager createStatisticsManager() throws IOException {
        return new MedeaStatisticsManager(this);
    }

    @Override
    protected TemplateManager createTemplateManager() throws IOException {
        return new MedeaTemplateManager(this);
    }

    @Override
    public String getName() {
        return "medea";
    }

    @Override
    protected String getFlavor() {
        return "oracle";
    }

    @Override
    public String parseSource(String source) {
        return source;
    }

    @Override
    public void run() {
    }
}
